#
# Copyright (C) 2007-2012 by Johan De Taeye, frePPLe bvba
#
# This library is free software; you can redistribute it and/or modify it
# under the terms of the GNU Affero General Public License as published
# by the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Affero
# General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public
# License along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# file : $URL: http://svn.code.sf.net/p/frepple/code/trunk/contrib/django/freppledb/output/urls.py $
# revision : $LastChangedRevision: 1713 $  $LastChangedBy: jdetaeye $
# date : $LastChangedDate: 2012-07-18 11:46:01 +0200 (Wed, 18 Jul 2012) $

from django.conf.urls import patterns

import freppledb.output.views.buffer
import freppledb.output.views.demand
import freppledb.output.views.problem
import freppledb.output.views.constraint
import freppledb.output.views.forecast
import freppledb.output.views.resource
import freppledb.output.views.operation
import freppledb.output.views.pegging
import freppledb.output.views.kpi


urlpatterns = patterns('',
    (r'^buffer/([^/]+)/$', freppledb.output.views.buffer.OverviewReport.as_view()),
    (r'^buffergraph/([^/]+)/$', freppledb.output.views.buffer.GraphData),
    (r'^buffer/$', freppledb.output.views.buffer.OverviewReport.as_view()),
    (r'^demand/([^/]+)/$', freppledb.output.views.demand.OverviewReport.as_view()),
    (r'^demandgraph/([^/]+)/$', freppledb.output.views.demand.GraphData),
    (r'^demand/$',  freppledb.output.views.demand.OverviewReport.as_view()),
    (r'^resource/([^/]+)/$', freppledb.output.views.resource.OverviewReport.as_view()),
    (r'^resourcegraph/([^/]+)/$', freppledb.output.views.resource.GraphData),
    (r'^resource/$', freppledb.output.views.resource.OverviewReport.as_view()),
    (r'^operation/([^/]+)/$', freppledb.output.views.operation.OverviewReport.as_view()),
    (r'^operationgraph/([^/]+)/$', freppledb.output.views.operation.GraphData),
    (r'^operation/$',  freppledb.output.views.operation.OverviewReport.as_view()),
    (r'^forecast/([^/]+)/$',  freppledb.output.views.forecast.OverviewReport.as_view()),
    (r'^forecastgraph/([^/]+)/$', freppledb.output.views.forecast.GraphData),
    (r'^forecast/$', freppledb.output.views.forecast.OverviewReport.as_view()),
    (r'^demandpegging/([^/]+)/$', freppledb.output.views.pegging.ReportByDemand.as_view()),
    (r'^pegginggraph/([^/]+)/$', freppledb.output.views.pegging.GraphData),
    (r'^bufferpegging/$', freppledb.output.views.pegging.ReportByBuffer.as_view()),
    (r'^resourcepegging/$', freppledb.output.views.pegging.ReportByResource.as_view()),
    (r'^operationpegging/$',  freppledb.output.views.pegging.ReportByOperation.as_view()),
    (r'^flowplan/$', freppledb.output.views.buffer.DetailReport.as_view()),
    (r'^problem/$', freppledb.output.views.problem.Report.as_view()),
    (r'^constraint/$', freppledb.output.views.constraint.Report.as_view()),
    (r'^operationplan/$', freppledb.output.views.operation.DetailReport.as_view()),
    (r'^loadplan/$', freppledb.output.views.resource.DetailReport.as_view()),
    (r'^demandplan/$', freppledb.output.views.demand.DetailReport.as_view()),
    (r'^kpi/$', freppledb.output.views.kpi.Report.as_view()),
)
